﻿namespace Scripts.IA
{
    using UnityEngine;
    using Scripts.Waypoints;

    public class Runners : MonoBehaviour
    {
        public float speed = 10f;

        private Transform target;
        private int waypointIndex = 0;

        void Start()
        {
            target = WaypointsFactory.getInstance().getWp()[0];

            float vitesse = (float.Parse(RunnersFactory.getInstance().getRandom().Next(75, 125).ToString()) / 100f) * 10f;
            speed = vitesse;
        }

        private void Update()
        {
            Vector3 dir = target.position - transform.position;
            transform.Translate(dir.normalized * speed * Time.deltaTime, Space.World);

            if (Vector3.Distance(transform.position, target.position) <= 0.3f) //Marge d'erreur
            {
                GetNextWaypoint();
            }
        }

        private void GetNextWaypoint()
        {
            if (waypointIndex >= WaypointsFactory.getInstance().getWp().Count - 1)
            {
                Destroy(gameObject);
                return;
            }

            waypointIndex++;
            target = WaypointsFactory.getInstance().getWp()[waypointIndex];
        }
    }
}